jQuery.fn.extend({
insertAtCaret: function(myValue){
  return this.each(function(i) {
    if (document.selection) {
      //For browsers like Internet Explorer
      this.focus();
      var sel = document.selection.createRange();
      sel.text = myValue;
      this.focus();
    }
    else if (this.selectionStart || this.selectionStart == '0') {
      //For browsers like Firefox and Webkit based
      var startPos = this.selectionStart;
      var endPos = this.selectionEnd;
      var scrollTop = this.scrollTop;
      this.value = this.value.substring(0, startPos)+myValue+this.value.substring(endPos,this.value.length);
      this.focus();
      this.selectionStart = startPos + myValue.length;
      this.selectionEnd = startPos + myValue.length;
      this.scrollTop = scrollTop;
    } else {
      this.value += myValue;
      this.focus();
    }
  });
}
});

jQuery(document).ready(function( $ ) {
  
	$('.elements a').on('click', function(e) {

		e.preventDefault();

		var $target = jQuery(this).attr('data-target');
		var $element = jQuery(this).text();

		jQuery('#' + $target).insertAtCaret($element);

		return false;
	});
	
	var $offset = 0;
	  
	$('#wxf_regenerate_xml').on('click', function( e ) {

		e.preventDefault();

		var $xml 	= parseInt( $(this).data( 'xml' ) );
		var $count 	= parseInt( $(this).data( 'count' ) );
		var $batch 	= parseInt( $(this).data( 'batch' ) );

		var data = {
			'action': 'ajax_regenerate',
			'offset': $offset,
			'feed_id': $xml
		};
		
		$('#wxf_regenerate_xml').css('visibility', 'hidden');
		$('.regenerate_progress').show();

		jQuery.post( ajaxurl, data, function( response ) {
			
			if ( response.data == 'continue' || $offset < $count ) {
				
				$offset = ( $offset + $batch );
				
				$('#wxf_regenerate_xml').attr( 'data-offset', $offset );
				
				$( '.regenerate_progress_inner' ).width( parseInt( $offset * 100 / $count )+'%' );
				
				var percentage = parseInt( $offset * 100 / $count );
				if ( percentage > 100 ) {
					percentage = 100;
				}				
				$( '.regenerate_pc' ).text( percentage +'%' );
				
				$('#wxf_regenerate_xml').trigger( 'click' );
				
			} else {
				$( '.regenerate_progress_inner' ).width( '100%' );
				$( '#wxf_regenerate_xml' ).css( 'visibility', 'visible' );
				$('#wxf_regenerate_xml').attr( 'data-offset', 0 );
				
				update_cached_file( JSON.parse( response ) );
			}
			
		});

		return false;
	});
	
	
	function update_cached_file( response ) {
		
		console.log( 'update' );
		console.log( response );
		console.log( response.result );
		
		$( '.regenerate_pc' ).text( response.result );
		$( '.cached_url a' ).attr( 'href', response.url );
		$( '.cached_url a' ).text( response.url );
		$( '.cached_url .filesize' ).text( response.filesize );
		$( '.cached_date_info' ).text( response.cached_date );
		
	}
  
});