<?php

function wcxml_out( $post_id, $numberofposts = -1, $offset = 0, $include_header = true, $include_footer = true ) {
  
	$wc_xml_header  = apply_filters('wxf_xml_header', get_post_meta( $post_id, 'wc_xml_header', true ), $post_id );
	$wc_xml_main    = apply_filters('wxf_xml_main', get_post_meta( $post_id, 'wc_xml_main', true ), $post_id );
	$wc_xml_footer  = apply_filters('wxf_xml_footer',  get_post_meta( $post_id, 'wc_xml_footer', true ), $post_id );

	$wc_xml_instock_msg       	= ( get_post_meta( $post_id, 'wc_xml_instock_msg', true ) );
	$wc_xml_outofstock_msg    	= ( get_post_meta( $post_id, 'wc_xml_outofstock_msg', true ) );
	$wc_xml_backorder_msg    	= ( get_post_meta( $post_id, 'wc_xml_backorder_msg', true ) );
	$wc_xml_displayoutofstock 	= ( get_post_meta( $post_id, 'wc_xml_displayoutofstock', true ) );
	$wc_xml_disbreadcrumb     	= ( get_post_meta( $post_id, 'wc_xml_disbreadcrumb', true ) );
	$wc_xml_breadcrumbsep     	= ( get_post_meta( $post_id, 'wc_xml_breadcrumbsep', true ) );

	$gensearch  = apply_filters('wxf_gensearch', array('{datetime}', '{site_title}', '{site_url}', '{site_description}'), $post_id);
	$genreplace = apply_filters('wxf_genreplace', array(date("Y-m-d H:i:s"), get_bloginfo( 'name' ), get_bloginfo( 'url' ), get_bloginfo( 'description' ) ), $post_id);

	$wc_xml_header = str_replace($gensearch, $genreplace, $wc_xml_header);
	$wc_xml_footer = str_replace($gensearch, $genreplace, $wc_xml_footer);

	$products_data = '';
	$parents = $search = array();

	$woo_array = apply_filters('wxf_all_products_array', wc_xml_feed_get_products( $post_id, $wc_xml_main, $numberofposts, $offset ), $post_id);

	if (!empty($woo_array)) {
		
		$woo_array_ready = array_values($woo_array);
		$woo_array_ready = array_shift($woo_array_ready);
		
		foreach ($woo_array_ready as $key => $val) {
			$search[] = '{'. $key .'}';
		}
		
	} else {
		
		return false;
	}
  
	$search = apply_filters('wxf_elements_array', $search, $post_id);

	// remove custom meta start/end tags
	$wc_xml_main = str_replace('%%', '', $wc_xml_main);

	foreach ($woo_array as $id => $singleprod) {

		$products_data .= str_replace($search, $singleprod, $wc_xml_main);

	}
	$xml_out = '';

	if ( $include_header ) {
		$xml_out .= $wc_xml_header;
	}
	
	$xml_out .= $products_data;
	
	if ( $include_footer ) {
		$xml_out .= $wc_xml_footer;
	}
	// return xml
	return $xml_out;
}



function wc_xml_feed_get_products( $post_id, $wc_xml_main, $numberofposts = -1, $offset = 0 ) {

  
  $wc_xml_images 				= get_post_meta($post_id, 'wc_xml_images', true);
  $wc_xml_attributes_implode 	= get_post_meta($post_id, 'wc_xml_attributes_implode', true);
  $wc_xml_parent_replace 		= get_post_meta($post_id, 'wc_xml_parent_replace', true);
  $wc_xml_displayoutofstock 	= get_post_meta($post_id, 'wc_xml_displayoutofstock', true);
  
  
  $wc_xml_breadcrumbsep = ( get_post_meta( $post_id, 'wc_xml_breadcrumbsep', true ) );
  
  if ($wc_xml_breadcrumbsep == '') {
    $wc_xml_breadcrumbsep = ', ';
  }
  
  $selected_wc_xml_product_cat = get_post_meta($post_id, 'wc_xml_product_cat', true);
  $tax_args = array();
  if (!empty($selected_wc_xml_product_cat)) {
    $tax_args = array(
      array(
        'taxonomy' => 'product_cat',
        'field'    => 'id',
        'terms'    => $selected_wc_xml_product_cat,
        'operator' => get_post_meta($post_id, 'wc_xml_product_categories_action', true),
      ),
    );
  }

    
  $post_type = array('product');
  $args = apply_filters('wxf_product_args', array(
      'post_type' 			=> $post_type,
      'suppress_filters' 	=> false,
      'post_status' 		=> 'publish',
      'fields' 				=> 'ids',
      'posts_per_page' 		=> $numberofposts,
	  'offset' 				=> $offset,
      'tax_query' 			=> $tax_args
    )
  );
  
  $products = array();
  $products_q = new WP_Query( $args );
  $products_ids = $products_q->posts;
  
  if( $products_ids ) {
    
    $_pf = new WC_Product_Factory();
    
    foreach( $products_ids as $key => $pid ) {
      
      // check if the product is excluded
      $excluded_entries = get_post_meta($pid, 'wooxml_exclude', true);
	  
	  if ( !is_array( $excluded_entries ) ) {
		$excluded_entries = explode( ',', str_replace( ', ', ',', $excluded_entries ) );
	  }
	  
      if ( !empty( $excluded_entries ) && is_array( $excluded_entries ) && in_array( $post_id, $excluded_entries ) ) {
        continue;
      }
      
      $wooxml_attributes_implode = get_post_meta( $pid, 'wooxml_attributes_implode', true );
      
      if ($wooxml_attributes_implode == 'default' || $wooxml_attributes_implode === NULL || $wooxml_attributes_implode == '') {
        $wooxml_attributes_implode = $wc_xml_attributes_implode;
      }
      
      $product = wc_get_product( $pid );
      
      if (apply_filters('wooxml_skip_product', false, $pid, $product, $post_id)) {
        continue;
      }
      
      if ($product->get_type() == 'variable' && !($wooxml_attributes_implode == 'yes' || $wooxml_attributes_implode == 'on') ) {
                
        $product = new WC_Product_Variable($pid);
        $variations = $product->get_available_variations();
      
        $get_attributes = $product->get_attributes();
      
        if (!empty($get_attributes)) {
                   
          if (!empty($variations)) {
            foreach($variations as $variation) {
              
              // ref: https://docs.woocommerce.com/wc-apidocs/class-WC_Product_Variation.html
              $product = $_pf->get_product($variation['variation_id']);
              
              $to_add = array();
              if ( $product->exists() && $product->variation_is_visible() && ( $product->is_in_stock() || $wc_xml_displayoutofstock == 'on' ) ) {
                
                $to_add = wooxml_variation($product, $post_id, $wc_xml_main);
                if (!empty($to_add)) {
                  $products[$product->get_id()] = $to_add;
                }
              }
            }
          
          }
        }
      } elseif ($product->get_type() == 'variable' && ($wooxml_attributes_implode == 'yes' || $wooxml_attributes_implode == 'on') ) {
        
        
        $to_add = array();
        $to_add = wooxml_product($product, $post_id, $wc_xml_main);
        if (!empty($to_add)) {
          $products[$pid] = $to_add;
        }
        
      } else { // the product is simple
        
        $to_add = array();
        $to_add = wooxml_product($product, $post_id, $wc_xml_main);
        if (!empty($to_add)) {
          $products[$pid] = $to_add;
        }
      }
      
    }    
  }
  return $products;

}


function wooxml_product( $product, $post_id, $wc_xml_main ) {
  
	$wc_xml_images            = get_post_meta($post_id, 'wc_xml_images', true);
	$wc_xml_attributes        = get_post_meta($post_id, 'wc_xml_attributes', true);
	$wc_xml_instock_msg       = get_post_meta($post_id, 'wc_xml_instock_msg', true);
	$wc_xml_outofstock_msg    = get_post_meta($post_id, 'wc_xml_outofstock_msg', true);
	$wc_xml_backorder_msg    	= get_post_meta($post_id, 'wc_xml_backorder_msg', true);
	$wc_xml_displayoutofstock = ( get_post_meta( $post_id, 'wc_xml_displayoutofstock', true ) );
	$weight_unit              = get_option( 'woocommerce_weight_unit' );
	$dimension_unit           = get_option( 'woocommerce_dimension_unit' );
	$wc_xml_attributes_title	= get_post_meta($post_id, 'wc_xml_attributes_title', true);

	$decimal_separator    = wc_get_price_decimal_separator();
	$thousand_separator   = wc_get_price_thousand_separator();
	$decimals             = wc_get_price_decimals();

	$wc_xml_breadcrumbsep = ( get_post_meta( $post_id, 'wc_xml_breadcrumbsep', true ) );

	if ($wc_xml_breadcrumbsep == '') {
		$wc_xml_breadcrumbsep = ', ';
	}

	$get_availability = array();
	$get_availability['class'] = '';
	$get_availability = $product->get_availability();
  
	if ( stripos( $get_availability['class'], 'in-stock' ) === false && $wc_xml_displayoutofstock != 'on') {
		return false;
	}
  
	if ( !( $product->is_in_stock() || $wc_xml_displayoutofstock == 'on' ) ) {
		return false;
	}
  
	if ($product->get_type() == 'variable') {
		$fin_product_price = number_format(floatval(get_post_meta($product->get_id(), 'wooxml_price', true)), $decimals, $decimal_separator, $thousand_separator);
	} else {
		$fin_product_price = number_format(floatval($product->get_price()), $decimals, $decimal_separator, $thousand_separator);
	}
  
	$products['datetime']   = date("Y-m-d H:i:s");
	$products['id']   = $product->get_id();
	$products['name'] = $product->get_title();
	$products['link'] = $product->get_permalink();
	$products['image'] = wp_get_attachment_url($product->get_image_id());
	$products['categories_tree'] = wc_xml_get_product_categories( $product->get_id(), $post_id );
	$products['categories'] = (get_the_term_list($product->get_id(), 'product_cat', '', ',', '') ? strip_tags(get_the_term_list($product->get_id(), 'product_cat', '', ',', '')) : '');
	$products['price_with_tax'] = number_format(floatval(wc_get_price_including_tax( $product )), $decimals, $decimal_separator, $thousand_separator);
	$products['price_without_tax'] = number_format(floatval(wc_get_price_excluding_tax($product)), $decimals, $decimal_separator, $thousand_separator);
	$products['regular_price'] = number_format(floatval($product->get_regular_price()), $decimals, $decimal_separator, $thousand_separator);
	$products['sales_price'] = number_format(floatval($product->get_sale_price()), $decimals, $decimal_separator, $thousand_separator);
	$products['price'] = $fin_product_price;
	$products['currency'] = get_woocommerce_currency();
	$products['display_price'] = wc_get_price_to_display( $product );
	$products['price_suffix'] = $product->get_price_suffix();
	$products['sku'] = $product->get_sku();
	$products['description'] = esc_html( $product->get_description() );
	$products['facebook_description'] = mb_strimwidth( strip_tags( $product->get_description() ), 0, 5000 );
	$products['excerpt'] = esc_html( $product->get_short_description() );
	$products['weight'] = $product->get_weight();
	$products['weight_unit'] = $weight_unit;
	$products['height'] = $product->get_height();
	$products['width'] = $product->get_width();
	$products['length'] = $product->get_length();
	$products['dimension_unit'] = $dimension_unit;
	$products['tags_tree'] = wc_xml_get_product_tags( $product->get_id(), $post_id );
	$products['tags'] = (get_the_term_list($product->get_id(), 'product_tag', '', $wc_xml_breadcrumbsep, '') ? strip_tags(get_the_term_list($product->get_id(), 'product_tag', '', $wc_xml_breadcrumbsep, '')) : '');
	$products['stock'] = $product->get_stock_status();
	$products['stock_status'] = $product->is_in_stock() ? 'y' : 'n';
	$products['stock_quantity'] = $product->get_stock_quantity();
	$products['total_stock'] = $product->get_stock_quantity();
	$products['tax_status'] = $product->get_tax_status();
	$products['tax_class'] = $product->get_tax_class();
	$products['avarage_rating'] = $product->get_average_rating();
	$products['rating_count'] = $product->get_rating_count();
	$products['review_count'] = $product->get_review_count();
	$products['featured'] = $product->is_featured() ? 'y' : 'n';
	$products['backorders'] = $product->backorders_allowed() ? 'y' : 'n';
	$products['visibility'] = $product->is_visible() ? 'y' : 'n';
	$products['fb_visibility'] = $product->is_visible() ? 'published' : 'hidden';
	$products['availability'] = ( stripos( $get_availability['class'], 'in-stock' ) !== false ? $wc_xml_instock_msg : $wc_xml_outofstock_msg );
	if ( stripos( $get_availability['class'], 'available-on-backorder' ) !== false ) {
		$products['availability'] = $wc_xml_backorder_msg;
	}
	$products['product_type'] = $product->get_type();
	$products['is_purchasable'] = $product->is_purchasable() ? 'y' : 'n';
	$products['shipping_class'] = $product->get_shipping_class();
	$products['brand'] = ( get_the_term_list($product->get_id(), 'product_brand', '', ',', '') && is_string(get_the_term_list($product->get_id(), 'product_brand', '', ',', '') ) ? strip_tags(get_the_term_list($product->get_id(), 'product_brand', '', ',', '')) : '');
	
	$shipping_class_id   = $product->get_shipping_class_id();
	$shipping_class_term = get_term($shipping_class_id, 'product_shipping_class');

	if( ! is_wp_error($shipping_class_term) && is_a($shipping_class_term, 'WP_Term') ) {
		$products['shipping_class_label']  = $shipping_class_term->name;
	}
	
  
	if ($products['brand'] == '' && $products['brand'] !== false) {
		$products['brand'] = get_post_meta( $post_id, 'wc_xml_default_brand', true );
	}
  
	$wooxml_get_custom_meta = wooxml_get_custom_meta($product, $post_id, $wc_xml_main, 'simple');
	if (!empty($wooxml_get_custom_meta)) {
		$products += $wooxml_get_custom_meta;
	}
  
  
	$products['images'] = '';
	if (!empty($product->get_gallery_image_ids()) && $wc_xml_images != '') {
		foreach($product->get_gallery_image_ids() as $galid) {
			$products['images'] .= str_replace('{image}', wp_get_attachment_url($galid), $wc_xml_images)."\n";
		}
	}
  
  $products['attributes'] = '';
  
	if ( $product->get_type() == 'variable' && $wc_xml_displayoutofstock != 'on' ) {
		
		$all_available_attributes = array();
		
		$variations = $product->get_available_variations();
		$variation_attributes = $product->get_variation_attributes();
		
		if ( !empty( $variations ) && is_array( $variations ) ) {
			foreach ( $variations as $var ) {
				
				if ( $var[ 'is_in_stock' ] == 1 ) {
					
					foreach( $var['attributes'] as $attr_key => $attr ) {
						
						$replaced_attr_key = str_replace( 'attribute_', '', $attr_key );
						
						if ( !empty( $attr ) ) {
							$all_available_attributes[ $replaced_attr_key ][] = $attr;
						} else {
							
							
							if ( isset( $variation_attributes[ $attr_key ] ) && !empty( $variation_attributes[ $attr_key ] ) && is_array( $variation_attributes[ $attr_key ] ) ) {
							
								foreach( $variation_attributes[ $attr_key ] as $any_attr ) {
									
									$all_available_attributes[ $replaced_attr_key ][] = $any_attr;
									
								}
							}
							if ( isset( $variation_attributes[ $replaced_attr_key ] ) && !empty( $variation_attributes[ $replaced_attr_key ] ) && is_array( $variation_attributes[ $replaced_attr_key ] ) ) {
							
								foreach( $variation_attributes[ $replaced_attr_key ] as $any_attr ) {
									
									$all_available_attributes[ $replaced_attr_key ][] = $any_attr;
									
								}
							}
							
						}
						
					}
					
				}
			}
		}
		
		if ( !empty( $all_available_attributes ) ) {
			
			
			$attributes = $product->get_attributes();
			
			foreach ( $all_available_attributes as $attr_key => $attr ) {
				
				$unique_attribute_labels[ $attr_key ][] = $product->get_attribute( $attr_key );
				
			}
			foreach ( $all_available_attributes as $attr_key => $attr ) {
				
				$new_attr_key = str_replace('attribute_pa_', '', $attr_key);
				$new_attr_key = rawurldecode( str_replace('pa_', '', $new_attr_key) );
				$attr_labels = implode( ', ', array_map( 'wc_attribute_label', $unique_attribute_labels[$attr_key] ) );
				$products['attributes'] .= str_replace(array('{attribute_label}', '{attribute_value}'), array($new_attr_key, $attr_labels), $wc_xml_attributes)."\n";
			}
		}
		
	} else {
  
		$attributes = $product->get_attributes();
		if (!empty($attributes)) {
		  
			$attr_labels = '';
			foreach ($attributes as $attr_key => $attr) {
				$new_attr_key = str_replace('attribute_pa_', '', $attr_key);
				$new_attr_key = rawurldecode( str_replace('pa_', '', $new_attr_key) );
				$attr_labels = wc_attribute_label($product->get_attribute($attr_key));
				$products['attributes'] .= str_replace(array('{attribute_label}', '{attribute_value}'), array($new_attr_key, $attr_labels), $wc_xml_attributes)."\n";
			}
			if ( $wc_xml_attributes_title == 'on' ) {
				$products['name'] .= ' '.$attr_labels;
			}

		}
	}

  // taxonomies
  $taxonomies = array();
  $taxonomies = wooxml_get_taxonomies();
  if (!empty($taxonomies)) {
    foreach ($taxonomies as $tax) {
      $products['tax_'.$tax] = wooxml_get_terms($product->get_id(), $tax);
    }
  }
  
  return apply_filters('wxf_single_product', $products, $product, $post_id);
  
}


function wooxml_variation( $product, $post_id, $wc_xml_main ) {
   
	$wc_xml_images            = get_post_meta($post_id, 'wc_xml_images', true);
	$wc_xml_attributes        = get_post_meta($post_id, 'wc_xml_attributes', true);
	$wc_xml_instock_msg       = get_post_meta($post_id, 'wc_xml_instock_msg', true);
	$wc_xml_outofstock_msg    = get_post_meta($post_id, 'wc_xml_outofstock_msg', true);
	$wc_xml_backorder_msg    	= get_post_meta($post_id, 'wc_xml_backorder_msg', true);
	$wc_xml_displayoutofstock = get_post_meta( $post_id, 'wc_xml_displayoutofstock', true );
	$weight_unit              = get_option( 'woocommerce_weight_unit' );
	$dimension_unit           = get_option( 'woocommerce_dimension_unit' );
	$wc_xml_attributes_title	= get_post_meta($post_id, 'wc_xml_attributes_title', true);
	$wc_xml_parent_replace 	= get_post_meta($post_id, 'wc_xml_parent_replace', true);

	$decimal_separator  = wc_get_price_decimal_separator();
	$thousand_separator = wc_get_price_thousand_separator();
	$decimals           = wc_get_price_decimals();
  
	$wc_xml_breadcrumbsep = ( get_post_meta( $post_id, 'wc_xml_breadcrumbsep', true ) );

	if ($wc_xml_breadcrumbsep == '') {
		$wc_xml_breadcrumbsep = ', ';
	}
  
	$get_availability = array();
	$get_availability['class'] = '';
	$get_availability = $product->get_availability();

	if ($get_availability['class'] != 'in-stock' && $wc_xml_displayoutofstock != 'on') {
		return false;
	}
  
	$parent_id 		= wooxml_get_parent_id($product);
	$parent_product 	= wc_get_product( $parent_id );

	$products['datetime']   = date("Y-m-d H:i:s");
	$products['id']   = $product->get_id();
	$products['name'] = $product->get_title();
	$products['link'] = $product->get_permalink();
	$products['image'] = wp_get_attachment_url($product->get_image_id());
	$products['categories_tree'] = wc_xml_get_product_categories( $parent_id, $post_id );
	$products['categories'] = (get_the_term_list($parent_id, 'product_cat', '', ',', '') ? strip_tags(get_the_term_list($parent_id, 'product_cat', '', ',', '')) : '');
	$products['price_with_tax'] = number_format(floatval(wc_get_price_including_tax( $product )), $decimals, $decimal_separator, $thousand_separator);
	$products['price_without_tax'] = number_format(floatval(wc_get_price_excluding_tax($product)), $decimals, $decimal_separator, $thousand_separator);
	$products['regular_price'] = number_format(floatval($product->get_regular_price()), $decimals, $decimal_separator, $thousand_separator);
	$products['sales_price'] = number_format(floatval($product->get_sale_price()), $decimals, $decimal_separator, $thousand_separator);
	$products['price'] = number_format(floatval($product->get_price()), $decimals, $decimal_separator, $thousand_separator);
	$products['currency'] = get_woocommerce_currency();
	$products['display_price'] = wc_get_price_to_display( $product );
	$products['price_suffix'] = $product->get_price_suffix();
	$products['sku'] = $product->get_sku();
	$products['description'] = esc_html( $product->get_description() );
	$products['facebook_description'] = mb_strimwidth( strip_tags( $product->get_description() ), 0, 5000 );
	$products['excerpt'] = esc_html( $product->get_short_description() );
	$products['weight'] = $product->get_weight();
	$products['weight_unit'] = $weight_unit;
	$products['height'] = $product->get_height();
	$products['width'] = $product->get_width();
	$products['length'] = $product->get_length();
	$products['dimension_unit'] = $dimension_unit;
	$products['tags_tree'] = wc_xml_get_product_tags( $parent_id, $post_id );
	$products['tags'] = (get_the_term_list($parent_id, 'product_tag', '', $wc_xml_breadcrumbsep, '') ? strip_tags(get_the_term_list($parent_id, 'product_tag', '', $wc_xml_breadcrumbsep, '')) : '');
	$products['stock'] = $product->get_stock_status();
	$products['stock_status'] = $product->is_in_stock() ? 'y' : 'n';
	$products['stock_quantity'] = $product->get_stock_quantity();
	$products['total_stock'] = $product->get_stock_quantity();
	$products['tax_status'] = $product->get_tax_status();
	$products['tax_class'] = $product->get_tax_class();
	$products['avarage_rating'] = $product->get_average_rating();
	$products['rating_count'] = $product->get_rating_count();
	$products['review_count'] = $product->get_review_count();
	$products['featured'] = $product->is_featured() ? 'y' : 'n';
	$products['backorders'] = $product->backorders_allowed() ? 'y' : 'n';
	$products['visibility'] = $product->is_visible() ? 'y' : 'n';
	$products['fb_visibility'] = $product->is_visible() ? 'published' : 'hidden';
	$products['availability'] = ((stripos( $get_availability['class'], 'in-stock' ) !== false || $get_availability['class'] == '') ? $wc_xml_instock_msg : $wc_xml_outofstock_msg);
	if ( stripos( $get_availability['class'], 'available-on-backorder' ) !== false ) {
		$products['availability'] = $wc_xml_backorder_msg;
	}
	$products['product_type'] = $product->get_type();
	$products['is_purchasable'] = $product->is_purchasable() ? 'y' : 'n';
	$products['shipping_class'] = $product->get_shipping_class();
	$products['brand'] = ( get_the_term_list($parent_id, 'product_brand', '', ',', '') && is_string(get_the_term_list($parent_id, 'product_brand', '', ',', '') ) ? strip_tags( get_the_term_list($parent_id, 'product_brand', '', ',', '') ) : '' );
	
	$shipping_class_id   = $product->get_shipping_class_id();
	$shipping_class_term = get_term($shipping_class_id, 'product_shipping_class');

	if( ! is_wp_error($shipping_class_term) && is_a($shipping_class_term, 'WP_Term') ) {
		$products['shipping_class_label']  = $shipping_class_term->name;
	}
  
	// get parent product excerpt and description if selected
	if ( empty( trim( $products['excerpt'] ) ) && $wc_xml_parent_replace == 'on' ) {
		$products['excerpt'] = esc_html( $parent_product->get_short_description() );
	}
	if ( empty( trim( $products['description'] ) ) && $wc_xml_parent_replace == 'on' ) {
		$products['description'] = esc_html( $parent_product->get_description() );
	}
  
	$wooxml_get_custom_meta = wooxml_get_custom_meta($product, $post_id, $wc_xml_main, 'variation');
	if (!empty($wooxml_get_custom_meta)) {
		$products += $wooxml_get_custom_meta;
	}
  
  
	$products['images'] = '';
	if (!empty($product->get_gallery_image_ids()) && $wc_xml_images != '') {
		foreach($product->get_gallery_image_ids() as $galid) {
			$products['images'] .= str_replace('{image}', wp_get_attachment_url($galid), $wc_xml_images)."\n";
		}
	}
  
	$products['attributes'] = '';
	$attributes = $product->get_variation_attributes();
  

	if (!empty($attributes)) {
    
		$variation_attributes_values = wcxml_get_variation_attributes_values($product);
		
		foreach ($attributes as $attr_key => $attr_value) {
			$new_attr_key = str_replace('attribute_pa_', '', $attr_key);
			$new_attr_key = str_replace('pa_', '', $new_attr_key);
		  
			if (!isset($variation_attributes_values[str_replace('attribute_', '', $attr_key)])) {
				$variation_attributes_values[str_replace('attribute_', '', $attr_key)] = '';
			}
		  
			$products['attributes'] .= str_replace(array('{attribute_label}', '{attribute_value}'), array($new_attr_key, $variation_attributes_values[str_replace('attribute_', '', $attr_key)]), $wc_xml_attributes)."\n";
		}
		
		if ( $wc_xml_attributes_title == 'on' ) {
			$products['name'] .= ' '.$variation_attributes_values[str_replace('attribute_', '', $attr_key)];
		}
	
	}
  
  
	// taxonomies
	$taxonomies = array();
	$taxonomies = wooxml_get_taxonomies();
	if (!empty($taxonomies)) {
		foreach ($taxonomies as $tax) {
			$products['tax_'.$tax] = wooxml_get_terms($product->get_id(), $tax);
		}
	}
  
	return apply_filters('wxf_single_product_variation', $products, $product, $post_id);
  
}

function wc_xml_get_product_categories( $product_id = null, $post_id = null ) {
  
	$wc_xml_breadcrumbsep = ( get_post_meta( $post_id, 'wc_xml_breadcrumbsep', true ) );

	if ($wc_xml_breadcrumbsep == '') {
		$wc_xml_breadcrumbsep = ' > ';
	}

	$output = '';
	$out_array = array();
	$term_taxonomy = 'product_cat';
	$categories = wp_get_object_terms( $product_id, $term_taxonomy );
	
	if( $categories ) {

		// get first id
		$first_cat = $categories[0]->term_id;

		// get parent categories
		$get_ancestors = get_ancestors($first_cat, $term_taxonomy, 'taxonomy');

		// put current as first
		array_unshift($get_ancestors, $first_cat);
		if (!empty($get_ancestors)) {
			foreach ($get_ancestors as $cat_id) {

				$term = get_term($cat_id, $term_taxonomy);
				$out_array[] = $term->name;

			}
		}

		$output = implode($wc_xml_breadcrumbsep, array_reverse($out_array, false));
	} else {
		$output = __( 'Uncategorized', 'wxf' );
	}
	return apply_filters('wxf_product_categories', $output, $product_id, $post_id);

}

function wc_xml_get_product_tags( $product_id, $post_id ) {

  $wc_xml_breadcrumbsep = ( get_post_meta( $post_id, 'wc_xml_breadcrumbsep', true ) );
  
  if ($wc_xml_breadcrumbsep == '') {
    $wc_xml_breadcrumbsep = ' > ';
  }

  $output = '';
  $term_taxonomy = 'product_tag';
  $tags = wp_get_object_terms( $product_id, $term_taxonomy );
  if( $tags ) {
    $size = count( $tags );
    for( $i = 0; $i < $size; $i++ ) {
      $tag = get_term( $tags[$i]->term_id, $term_taxonomy );
      $output .= $tag->name . $wc_xml_breadcrumbsep;
    }
    $output = rtrim( $output, $wc_xml_breadcrumbsep );
    $output = implode($wc_xml_breadcrumbsep, array_reverse(explode($wc_xml_breadcrumbsep, $output), false));
    
  }
  return apply_filters('wxf_product_tags', $output, $product_id, $post_id);

}


function wcxml_get_variation_attributes_values( $product ) {
  $variation_data = $product->get_variation_attributes();
  $parent_prod 	  = wc_get_product( $product->get_parent_id() );
  $attributes     = $parent_prod->get_attributes();
  $description    = array();
  $return         = '';

  if ( is_array( $variation_data ) ) {

      

      foreach ( $attributes as $attribute ) {

          // Only deal with attributes that are variations
          if ( ! $attribute[ 'is_variation' ] ) {
              continue;
          }

          $variation_selected_value = isset( $variation_data[ 'attribute_' . sanitize_title( $attribute[ 'name' ] ) ] ) ? $variation_data[ 'attribute_' . sanitize_title( $attribute[ 'name' ] ) ] : '';
          $description_name         = rawurldecode( esc_html(  $attribute[ 'name' ] ) );
          $description_value        = __( 'Any', 'wxf' );

          // Get terms for attribute taxonomy or value if its a custom attribute
          if ( $attribute[ 'is_taxonomy' ] ) {

              $post_terms = wp_get_post_terms( $parent_prod->get_id(), $attribute[ 'name' ] );

              foreach ( $post_terms as $term ) {
                  if ( $variation_selected_value === $term->slug ) {
                      $description_value = esc_html( $term->name );
                  }
              }

          } else {

              $options = wc_get_text_attributes( $attribute[ 'value' ] );

              foreach ( $options as $option ) {

                  if ( sanitize_title( $variation_selected_value ) === $variation_selected_value ) {
                      if ( $variation_selected_value !== sanitize_title( $option ) ) {
                          continue;
                      }
                  } else {
                      if ( $variation_selected_value !== $option ) {
                          continue;
                      }
                  }

                  $description_value = esc_html( apply_filters( 'woocommerce_variation_option_name', $option ) );
              }
          }

          
              $description[$description_name] = rawurldecode( $description_value );
          
      }


          $return = $description;


  }

  return $return;
}


function wooxml_get_custom_meta( $product, $post_id, $wc_xml_main, $type = 'simple' ) {
  
  $meta_arr = array();
  $meta_arr = wooxml_get_inbetween('%%', '%%', $wc_xml_main);
  
  $parent_id = wooxml_get_parent_id($product);
  
  $products_custom_meta = array();
  
  if (empty($meta_arr)) { return $products_custom_meta; }
  
  foreach($meta_arr as $meta_key) {
    $products_custom_meta[$meta_key] = get_post_meta($product->get_id(), $meta_key, true);
    
    // check the parent product if it exists and the key does not exists on current
    if( !in_array( $meta_key, get_post_custom_keys( $product->get_id() ) ) &&  ($type != 'simple' && isset($product->parent) && in_array( $meta_key, get_post_custom_keys( $parent_id ) ))) {
      $products_custom_meta[$meta_key] = get_post_meta($parent_id, $meta_key, true);
    }
    $products_custom_meta[$meta_key] = apply_filters('wooxml_custom_meta_'.$meta_key, $products_custom_meta[$meta_key], $product, $post_id, $type);
  }
  
  return $products_custom_meta;
  
}

function wooxml_get_taxonomies() {
  
  $tax = $taxonomies = array();
  
  $taxonomies = get_object_taxonomies('product');
  
  if (!empty($taxonomies)) {
    foreach ($taxonomies as $t) {
      if (substr( $t, 0, 3 ) !== 'pa_' && $t != 'product_cat' && $t != 'product_tag' && $t != 'product_shipping_class') {
        $tax [] = $t;
      }
    }
  }
  
  return $tax;
}

function wooxml_get_terms($post_id, $taxonomy, $args = array("fields" => "names")) {
  
  $terms = $out = '';
  $terms = wp_get_post_terms( $post_id, $taxonomy, $args );
  
  if (!is_wp_error( $terms ) && !empty($terms)) {
    $out = implode (', ', $terms);
  }
  
  return $out;
}


function wooxml_get_inbetween( $start, $end, $str ){
    $matches = array();
    $regex = "/$start([a-zA-Z0-9_]*)$end/";
    preg_match_all($regex, $str, $matches);
    return $matches[1];
}


function wooxml_get_parent_id( $prod_obj ) {
  if (WC_VERSION < 3.0) {
    return $prod_obj->post->ID;
  } else {
    return $prod_obj->get_parent_id();
  }
}


function nitro_generate_product_meta_keys() {
    global $wpdb;
    $post_type = 'product';
    $query = "
        SELECT DISTINCT($wpdb->postmeta.meta_key) 
        FROM $wpdb->posts 
        LEFT JOIN $wpdb->postmeta 
        ON $wpdb->posts.ID = $wpdb->postmeta.post_id 
        WHERE $wpdb->posts.post_type = '%s' 
        AND $wpdb->postmeta.meta_key != '' 
        AND $wpdb->postmeta.meta_key NOT RegExp '(^[_0-9].+$)' 
        AND $wpdb->postmeta.meta_key NOT RegExp '(^[0-9]+$)'
    ";
    $meta_keys = $wpdb->get_col($wpdb->prepare($query, $post_type));
    set_transient('nitro_products_meta_keys', $meta_keys, 60*60*24); # create 1 Day Expiration
    return $meta_keys;
}

function nitro_get_product_meta_keys() {
    $cache = get_transient('nitro_products_meta_keys');
    $meta_keys = $cache ? $cache : nitro_generate_product_meta_keys();
	
	$result = json_decode($meta_keys);

	if (json_last_error() === JSON_ERROR_NONE) {
		// JSON is valid
		return $result;
	}
	
    return $meta_keys;
}

// add columns
// Add the custom columns to the wc_xml_feeds post type:
add_filter( 'manage_wc_xml_feeds_posts_columns', 'set_custom_edit_wc_xml_feeds_columns' );
function set_custom_edit_wc_xml_feeds_columns( $columns ) {
	
	
	$new = array_merge(array_slice($columns, 0, 1), array( 'xml_id' => __( 'ID', 'wxf' ) ), array_slice($columns, 1));

    return $new;
}

// Add the data to the custom columns for the wc_xml_feeds post type:
add_action( 'manage_wc_xml_feeds_posts_custom_column' , 'custom_wc_xml_feeds_column', 10, 2 );
function custom_wc_xml_feeds_column( $column, $post_id ) {
    switch ( $column ) {

        case 'xml_id' :
            echo $post_id;
            break;

        

    }
}


// regenerate via ajax
add_action( 'wp_ajax_nopriv_ajax_regenerate', 'wooxml_ajax_regenerate' );
add_action( 'wp_ajax_ajax_regenerate', 'wooxml_ajax_regenerate' );
function wooxml_ajax_regenerate() {
	
	$offset 		= intval( $_POST[ 'offset' ] );
	$feed_id = intval( $_POST[ 'feed_id' ] );
	
	$out = 'continue';
	
	$wc_xml_filename = esc_sql( get_post_meta( $feed_id, 'wc_xml_filename', true ) );
	
	$include_header= false;
	
	if ( $offset == 0 ) {
		$include_header = true;
		if ( file_exists( get_home_path().$wc_xml_filename ) ) {
			unlink( get_home_path().$wc_xml_filename );
		}
		update_post_meta( $feed_id, 'wc_xml_last_cached', date_i18n('U'));
        update_post_meta( $feed_id, 'wc_xml_cached_url', get_site_url().'/'.esc_sql( $wc_xml_filename ) );
		
	}
	
	$wcxml_out = wcxml_out( $feed_id, apply_filters( 'wxf_batch_size', 100, $feed_id ), $offset, $include_header, false );
	
	if ( $wcxml_out ) {
		file_put_contents(get_home_path().$wc_xml_filename, $wcxml_out, FILE_APPEND );
	} else {
		
		$wc_xml_footer  = apply_filters('wxf_xml_footer',  get_post_meta( $feed_id, 'wc_xml_footer', true ), $feed_id );

		$gensearch  = apply_filters('wxf_gensearch', array('{datetime}'), $feed_id);
		$genreplace = apply_filters('wxf_genreplace', array(date("Y-m-d H:i:s")), $feed_id);

		$wc_xml_footer = str_replace( $gensearch, $genreplace, $wc_xml_footer );
		
		file_put_contents(get_home_path().$wc_xml_filename, $wc_xml_footer, FILE_APPEND );
		
		$out = 'finish';
		
		update_post_meta( $feed_id, 'wc_xml_last_cached', date_i18n('U') );
		
		$filesize 		= '('. round(filesize( get_home_path().$wc_xml_filename ) / 1024 / 1024, 2) .' MB)';
		$cached_date 	= date_i18n( get_option( 'date_format' ) .' '. get_option( 'time_format' ), get_post_meta( $feed_id, 'wc_xml_last_cached', true ) );
		
		$json = apply_filters( 'wcxml_json_finish_reply', array(
				'success' 		=> true, 
				'result' 		=> $out, 
				'url' 			=> get_site_url().'/'.esc_sql( $wc_xml_filename ),
				'filename' 		=> $wc_xml_filename, 
				'filesize' 		=> $filesize,
				'cached_date' 	=> $cached_date 
			),
			$feed_id
		);
		
		echo json_encode( $json );
		wp_die();
	}
	
	
	wp_send_json_success( $out );
	wp_die();
	
}
